/*   
     
Chess-Ec    Copyright (C)   2001-2008 Marc Dechico


      ec_prt.h : printing data on screen (chess board and collected data) 
  
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 To contact the author:	Marc Dechico
 Kerfring
 29390 SCAER France
 tel: 06 37 98 22 54
 Mail: ec@chess-ec.org  
    
*/


#include "ec_prt.h"


/*  Affichage  piece   */
void 
aff_pie (int i_cam)
{
  int i_pie ;
  if(i_cam!=0 && i_cam!=1)
    return;
  printf("%s",tc_sep_tir);
  /* \nTableau camp :  %d  */ 
  printf( _("\nSide :  %d") ,i_cam);
  /*  \nId\tPs\tPp\tX\tY\tFor\tLib\tTdir\tNdir */
  printf( _("\nId\tnP\tpP\tX\tY\tPwr\tLib\tTdir\tNdir") );
  for (i_pie = 0; i_pie < 18;i_pie++)
    aff_pie_lin(i_pie,tpts_pie[i_cam]+i_pie);
	

}
/*  Affichage  piece presentes   */
/*
static void 
aff_pie_pre (int i_cam)
{
  struct st_pie *pts_pie_ct;
  if(i_cam!=0 && i_cam!=1)
    return;
  printf("%s",tc_sep_tir);
  // \nTableau camp :  %d 
  printf( _("\nSide :  %d") ,i_cam);
  //  \nId\tPs\tPp\tX\tY\tFor\tLib\tTdir\tNdir 
  printf( _("\nId\tnP\tpP\tX\tY\tPwr\tLib\tTdir\tNdir") );
  pts_pie_ct=tpts_pie[i_cam] ;

  for (	pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
	;
	pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)
    {
      aff_pie_lin(0,pts_pie_ct);
      if (pts_pie_ct->i_pie_sui==17) break;
    }

}
*/  
void aff_pie_lin(int i_pie,struct st_pie *ptst_pie)
{
  printf("\n%d\t",i_pie);
  printf("%d\t",ptst_pie->i_pie_sui);
  printf("%d\t",ptst_pie->i_pie_pre);
  printf("%s\t",tc_lib_cas[ptst_pie->i_pos_n]);
  printf("%i\t",ptst_pie->i_for);
  printf("%c\t",ptst_pie->c_lib_pie);

}
/*  Affichage  historique  */
void aff_hst_wra (int i_pro_deb, int i_pro_fin)
{ 
  aff_hst(i_pro_deb, i_pro_fin);
}
void aff_hst (int i_pro_deb, int i_pro_fin)
{ 
  /*  Affichage  historique  */
  int pro;
  if (i_pro_fin == 0) i_pro_fin = pts_hst_pro->i_pro;

  printf("%s",tc_sep_tir);
  /* \nTableau historique prof de %d a %d */
  printf( _("\nHistory deepness from %d to %d ") ,i_pro_deb,i_pro_fin);
  /* \nPro\tId\to_x\to_y\tx\ty\tId2 */
  printf( _("\nDee\tId\td_n\tn\tId2") );
  /* \n\tTyp_mvt\tDir_pri\tDir_dem\tDir_dpc */
  printf( _("\n\tMvt_Typ\tMai_Dir\tDir_dem\tDir_dos") );
  /* \n\tNote\tNot max\tPat\tMat */
  printf( _("\n\tMark\tMax Mrk\tPat\tMat") );

  for (pro = i_pro_deb; pro <= i_pro_fin; pro++)
    {
      /*0         1         2         3         4    */
      /*12345678901234567890123456789012345678901234567890*/
      printf(tc_sep_tir);
	
      printf("\n%d\t",pro);

      printf("%c\t",(tpts_pie[ts_hst_pro[pro].i_cam]+ts_hst_pro[pro].i_Id)->c_lib_pie);


		
      printf("%s\t",tc_lib_cas[ts_hst_pro[pro].i_pos_ori_n]);
      printf("%s\t",tc_lib_cas[ts_hst_pro[pro].i_pos_n]);
      printf("%d\t",ts_hst_pro[pro].i_Id_2p);
			
      printf("\n\t");
      printf("%d\t",ts_hst_pro[pro].i_typ_mvt);
			
      printf("%d\t",ts_hst_pro[pro].i_ech_dir_pri);
      printf("%d\t",ts_hst_pro[pro].i_ech_dir_dem);
      printf("%d",ts_hst_pro[pro].i_ech_dir_dem_p_c);
		
      printf("\n\t");
      printf("%d\t",ts_hst_pro[pro].i_not);
      printf("%d\t",ts_hst_pro[pro].i_not_max);
      printf("%d\t",ts_hst_pro[pro].defv_pat);
      printf("%d\t",ts_hst_pro[pro].defv_mat);
      printf(  "ech:%d\t",ts_hst_pro[pro].defv_ech);
      printf("Rf:%d\t",ts_hst_pro[pro].i_rap_for);
      printf("Rpc:%d",ts_hst_pro[pro].i_pos_n_R_p_c);
		
# if CPT_ITE == 1
      printf("cpt:%li",ts_hst_pro[pro].cpt);
# endif
    }

}

/*  Affichage  notes nouvelle version  */
int aff_not_1 (int *pi_mei_mvt)
{
  /* org ajouter parametre pour le nbr de ligne par page */
  int i_mei_mvt=*pi_mei_mvt;
  int i_msg;
  int cpt,cpt2;
  int i_fir_lig;
  /* type note à afficher  */
  enum typ_not te_tn []=  	
    {
      nbr_mat,
      nbr_mat_rf,
      nbr_mat_inc,
      nbr_pat,
      nbr_pat_rf,
      nbr_pat_inc
    };

  ST_NOT_MVT_INI *pts_mvt;
  struct st_aff *pts_aff=&tst_aff[e_aff_not_1];
  pts_aff->i_nbr_lig_pag=8;
  pts_aff->arguments =pi_mei_mvt;
  pts_aff->pf_aff =aff_not_1;

  i_msg=ver_aff_not_pos();
  if(i_msg<0)  return i_msg;		
	
  printf("%s",tc_sep_tir);
  printf("\n");

  /* printf(" N pDeAr Not	"    */
  printf( _(" N pFrTo CapMar S"    ) );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",lib_typ_not[te_tn[cpt2]].label);
 


  printf("%s",tc_sep_tir);

  /* détermine la première ligne à afficher */
  i_fir_lig = pts_aff->i_nbr_lig_pag *  pts_aff->i_cur_pag
              -
              pts_aff->i_cur_pag ; /*reafficher la dernière ligne */

  for (cpt =i_fir_lig;
       cpt<  i_fir_lig +  pts_aff->i_nbr_lig_pag
	 &&
	 cpt<=i_not_cpt_mvt_ini-1;  
       cpt++ )
    {
      pts_mvt = ts_tri_mvt_ini[cpt].pts_tri_rec;
      /* première ligne */		
      printf("\n%2u",pts_mvt->i_num_mvt);
      printf(" %c",pts_mvt->c_lib_pie);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      if   (pts_mvt->i_typ_mvt_pri_lea)
	printf( "!");
      else
	printf(" ");
      printf( "%i", pts_mvt->i_not_pri);
      printf("\t");
      printf( _("W") );
      for (cpt2=0;cpt2<(int)( sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	{
	  print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_cam_bru[BLANC]);
	}

      /* seconde ligne */
      printf("\n\t\t");
      printf( _("B") );
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	{
	  print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_cam_bru[NOIR]);
	}
#ifdef UPLOAD_BRANCHE  
      printf("\n\t\t");
      bra_prt_lst( pts_mvt->pst_bra_nod);
#endif
 	
	
    }
  /* mémorise si première ou drenière page */
  /* if the last record has been printed cpt = nbr of record 
     for record one cpt=0 but cpt is incremented again by the loop for.  
     i_not_cpt_mvt_ini = nbr of record : begin at 0 for the first record but 
     incremented again after the last record has been created */
  if (cpt == i_not_cpt_mvt_ini)  
    pts_aff->i_las_pag=TRUE;

  else
    pts_aff->i_las_pag=FALSE;
  if ( pts_aff->i_cur_pag==0)  
    pts_aff->i_fir_pag=TRUE;
  else
    pts_aff->i_fir_pag=FALSE;

  /* */
  printf("%s",tc_sep_tir);
 
  if(i_mei_mvt>=0)  
    /*printf("\nMei_mvt:%d->%s%s  Piece=%c  Camp=%d Niv=%d,%d ",*/
    printf("\n");

  printf( _("Best_move:%d->%c_%s%s") ,
	  i_mei_mvt,
	  ts_not_mvt_ini[i_mei_mvt].c_lib_pie,
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_ori_n],
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_arr_n]
	  );
  if ( pts_aff->i_las_pag == FALSE)
    /*   printf(" Page suivant: +");*/
    printf( _(" Next_page:+") );
 
  if ( pts_aff->i_fir_pag == FALSE)
    /*  printf(" Page precedent: -");*/
    printf( _(" Previous_page:-") );
 

  return 0;
}

/*  Affichage  notes nouvelle version  */
int aff_not_2 (int *pi_mei_mvt)
{
  int i_mei_mvt=*pi_mei_mvt;
  int i_msg2;
  int cpt,cpt2;
  int i_fir_lig;
  int i_tot_coe;
  /* type note à afficher  */
  enum typ_not te_tn []=  	
  {
    nbr_mat,
    nbr_mat_rf,
    nbr_mat_inc,
    nbr_pat,
    nbr_pat_rf,
    nbr_pat_inc,
    cou_pie, 
    nbr_fou, 
    mob_pie, 
    pos_pie	
  };


  ST_NOT_MVT_INI *pts_mvt;

  struct st_aff *pts_aff=&tst_aff[e_aff_not_2];

  pts_aff->i_nbr_lig_pag=10;
  pts_aff->arguments =pi_mei_mvt;
  pts_aff->pf_aff =aff_not_2;
  i_msg2=ver_aff_not_pos();

  if(i_msg2<0)  return i_msg2;		
  printf("%s",tc_sep_tir_120);

  /* Coefficiant */
  printf("\n");
  printf( _("Coefficient") );
  printf("\t");
  i_tot_coe=0;
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    {
      i_tot_coe+= st_eva_sit.ti_coe_pon[te_tn[cpt2]];
      printf(" %9d", st_eva_sit.ti_coe_pon[te_tn[cpt2]]); 
    }
  printf(" %9d", i_tot_coe); 

  /* Entete de colone */
  printf("\n");
  printf( _(" N pFrTo CapMar "    ) );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",lib_typ_not[te_tn[cpt2]].label);
  /* Detail par mouvement */ 
  printf("%s",tc_sep_tir_120);
  i_fir_lig = pts_aff->i_nbr_lig_pag *  pts_aff->i_cur_pag
    -
    pts_aff->i_cur_pag ; /*reafficher la dernière ligne */
  for (cpt =i_fir_lig;
       cpt<  i_fir_lig +  pts_aff->i_nbr_lig_pag
	 &&
	 cpt<=i_not_cpt_mvt_ini-1;
       cpt++ )
    {
      pts_mvt = ts_tri_mvt_ini[cpt].pts_tri_rec;
      /* première ligne */		
      printf("\n%2u",pts_mvt->i_num_mvt);
      printf(" %c",pts_mvt->c_lib_pie);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf( " %i", pts_mvt->i_not_pri);
      printf("\t");
      
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
        print_sci_nbr( pts_mvt->tst_not[te_tn[cpt2]].f_not_dif_pon);
      
      /* seconde ligne */
      printf("\n\t");
      printf("\t");
      
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	printf( "       %3d", pts_mvt->tst_not[te_tn[cpt2]].i_not_pon_rec);
      
      print_sci_nbr(pts_mvt->f_tot_rec_pon);
			
	
    }
  /* mémorise si première ou drenière page */
  /* if the last record has been printed cpt = nbr of record 
     for record one cpt=0 but cpt is incremented again by the loop for.  
     i_not_cpt_mvt_ini = nbr of record : begin at 0 for the first record but 
     incremented again after the last record has been created */

  if (cpt == i_not_cpt_mvt_ini)  
    pts_aff->i_las_pag=TRUE;
  else
    pts_aff->i_las_pag=FALSE;
  if ( pts_aff->i_cur_pag==0)  
    pts_aff->i_fir_pag=TRUE;
  else
    pts_aff->i_fir_pag=FALSE;

  /* */
  printf("%s",tc_sep_tir_120);

  /* valeur maximum */
  printf("\n");
  printf("%s", _("maximum") );
  printf("\t\t");

  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)	
    print_sci_nbr(st_eva_sit.tst_int_not[te_tn[cpt2]].max);

  /* Valeur minimum */
  printf("\n");
  printf("%s", _("minimum") );
  printf("\t\t");

  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)	
    print_sci_nbr(st_eva_sit.tst_int_not[te_tn[cpt2]].min);

  printf("%s",tc_sep_tir_120);

  if(i_mei_mvt>=0)  
    printf("\n");
  printf( _("Best_move:%d->%c_%s%s") ,
	  i_mei_mvt,
	  ts_not_mvt_ini[i_mei_mvt].c_lib_pie,
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_ori_n],
	  tc_lib_cas[ts_not_mvt_ini[i_mei_mvt].i_pos_arr_n]	
	  );
  printf("\t\t");
 
  if ( pts_aff->i_las_pag == FALSE)
    printf( _(" Next_page:+") );

  if ( pts_aff->i_fir_pag == FALSE)
    printf( _(" Previous_page:-") );

  return 0;
}

void aff_nex_pag()
{
  struct st_aff *pts_aff=&tst_aff[e_cur_aff];

  if (e_cur_aff != e_pas_aff)
    {
      if ( pts_aff->i_las_pag==FALSE)
	pts_aff->i_cur_pag++;
      else
	printf("\a"); /* alarme */

    }
  else return;
  (*pts_aff->pf_aff)(pts_aff->arguments);
}
void aff_pre_pag()
{
  struct st_aff *pts_aff=&tst_aff[e_cur_aff];
  if (e_cur_aff != e_pas_aff)
    {
      if ( pts_aff->i_fir_pag==FALSE)
	pts_aff->i_cur_pag--;
      else
	printf("\a"); /* alarme */
    }
  else return;
  (*pts_aff->pf_aff)(pts_aff->arguments);

}
/*
static int 
aff_not_debug (void)
{
  int cpt_mvt;
  ST_NOT_MVT_INI *pts_mvt;


  printf("\n%s",tc_sep_tir);
  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
    {
      pts_mvt = &ts_not_mvt_ini[cpt_mvt];
      printf("\n%2u",pts_mvt->i_num_mvt);
      printf(" %s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf("%i",pts_mvt->i_nbr_rep_sit);	
    }
	
  return 0;
}
*/
int aff_mvt_ini(int i_mvt_ini)
{  
  int i_msg;
  int cpt2;
  int p;		/* profondeur */
  ST_NOT_MVT_INI *pts_mvt;
  /* type note à afficher  */
  enum typ_not te_tn []=  	
  {
    nbr_mvt,
    nbr_mat,
    nbr_mat_rf,
    nbr_mat_inc,
    nbr_pat,
    nbr_pat_rf,
    nbr_pat_inc,
    nbr_fou, 
  };

  /* Verification note disponible */
  i_msg=ver_aff_not_pos();
  if(i_msg<0)    return i_msg;

  /* verification existance mvt */
  i_msg=ver_exi_mvt_ini(i_mvt_ini);
  if(i_msg<0)    return i_msg;

  pts_mvt = &ts_not_mvt_ini[i_mvt_ini];  

  /* Affichage mvt */
  /*"Num:%i  Mvt:%c %s%s"*/
  printf( _("Number:%i Movement:%c %s%s") , 
	  i_mvt_ini,
	  pts_mvt->c_lib_pie,
	  tc_lib_cas[pts_mvt->i_pos_ori_n],
	  tc_lib_cas[pts_mvt->i_pos_arr_n]
	  );

  /* affichage entete de colone */
  printf("%s",tc_sep_tir);
  printf("\n");
  /*   printf(" p I C ");*/
  printf( _(" D I  S") );
  for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
    printf("%s",lib_typ_not[te_tn[cpt2]].label);


  printf("%s",tc_sep_tir);

  /*affichage du détail par profondeur */

  for(p=0;p< (pts_mvt->i_pro_sim+pts_mvt->i_inc_pro_sim-1);p++)
    {
      printf("\n");
      printf ("%2i ",p+2);
      printf ("%i  ", tst_pro_sta[pts_mvt->i_num_mvt][p].i_inc);
      if ( tst_pro_sta[pts_mvt->i_num_mvt][p].i_cam == BLANC)
	printf ( _("W") );
      else
	printf ( _("B") );
      for (cpt2=0;cpt2<(int) (sizeof(te_tn)/sizeof(enum typ_not));cpt2++)
	{
	  print_sci_nbr(  tst_pro_sta[pts_mvt->i_num_mvt][p].f_dat_pro[te_tn[cpt2]]);
	}


    }
  return 0;
}
void aff_cal_en_cou(int i_not_cpt_mvt_ini,int i_aff_typ)
{
  
  if(defv_aff_cal_cou == Y )
    {
      switch (i_aff_typ)
	{
	case 0:
	  printf("\nnum:");
	  printf("%2i: ",i_not_cpt_mvt_ini);
	  printf(" mvt:");
	  printf("%s",tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_ori_n]);
	  printf("%s",tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_arr_n]);
	  break;
	case 1:
	  printf("%s",tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_ori_n]);
	  printf("%s|",tc_lib_cas[ts_not_mvt_ini[i_not_cpt_mvt_ini].i_pos_arr_n]);
	  break;
	case 2:
	  printf(".");
	default:
	  printf(".");
	}
#if CPT_ITE == 1
      printf("cpt_ite:%lu", cpt);	
#endif
      fflush(stdout);
    }
}

static void for_nul_sci_nbr (char *str)  
{
  /* si valeur nulle supprime la notation sciatifique */
  if (strcmp(str,"+0.00e+00")==0)    strcpy(str,  "        0");
}
static void print_sci_nbr (float f_nbr)
{
  /* Imprime un nombre de type float 
     si la vlaeur = 0 supprime la notation scientifique */ 
  char tc_nbr[11]; 
  sprintf(tc_nbr,"%+2.2e",f_nbr);
  for_nul_sci_nbr(tc_nbr);
  printf(" %s",tc_nbr);
}

