/*   
     
Chess-Ec    Copyright (C)   2001-2008 Marc Dechico


 ec_memlst.h: Memmory liste .
   
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 To contact the author:	Marc Dechico
 Kerfring
 29390 SCAER France
 tel: 06 37 98 22 54
 Mail: ec@chess-ec.org  
*/
#include "ec_global.h"

/******************************************************************************/
/* external datas */
/******************************************************************************/

extern char *progname;

/******************************************************************************/
/* local function */
/******************************************************************************/
int mem_lst_ini  (struct st_ind  **ppst_cur_ind);
int mem_lst_add  (struct st_ind  **pst_cur_ind, void * p_new_mem);
int mem_lst_fre  (struct st_ind  **ppst_cur_ind);
int mem_lst_lst  (struct st_ind  *pst_cur_ind);
void * mem_malloc ( unsigned int size);
